# coding=utf-8
#
#   Copyright 2014 Thadeu Lima de Souza Cascardo <cascardo@cascardo.info>
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
# -*- mode: python; encoding: utf-8; -*-

class BaseUI():
    def get_string(self, prompt=""):
        return raw_input(prompt.encode("utf-8"))
    def menu(self, list):
        i = 1
        for l in list:
            self.show_item(str(i) + ". " + l)
            i += 1
        ans = self.get_string("Option: ")
        try:
            opt = int(ans)
            if opt >= i:
                return -1
            return opt - 1
        except Exception, e:
            return -1
    def show_item(self, s):
        print s
    def item(self):
        menu = [ "Exit", "Edit", "Delete" ]
        actions = [ None, "edit", "delete" ]
        r = self.menu(menu)
        if r >= 0:
            return actions[r]
        return None
    def list(self, ls):
        self.show_item("0. Exit")
        self.show_item("1. Add")
        i = 2
        for l in ls:
            self.show_item(str(i) + ". " + l)
            i += 1
        ans = self.get_string("Option: ")
        try:
            opt = int(ans)
            if opt >= i or opt <= 0:
                return (-1, None)
            elif opt == 1:
                return (-1, "add")
            return (opt - 1, self.item())
        except Exception, e:
            return (-1, None)
    def form(self, fs):
        exit = False
        while not exit:
            self.show_item("0. Exit")
            i = 1
            for f in fs:
                if f.get_type() == "string":
                    self.show_item(str(i) + ". " + f.get_name() + ": " + f.get_value())
                elif f.get_type() == "options":
                    self.show_item(str(i) + ". " + f.get_name() + ": " + f.get_cur_display())
                i += 1
            ans = self.get_string("Option: ")
            try:
                opt = int(ans)
                if opt >= i:
                    # raise/show error/message about wrong option
                    opt = -1
            except Exception, e:
                raise e
            if opt == 0:
                exit = True
            else:
                self.show_form(fs[opt - 1])
    def show_form(self, f):
        if f.get_type() == "string":
            self.show_item(f.get_name() + ": " + f.get_value())
            s = self.get_string(f.get_name() + ": ")
            f.set_value(s)
        elif f.get_type() == "options":
            self.show_options(f)
    def show_options(self, f):
        self.show_item(f.get_name() + ": " + f.get_cur_display())
        for i in range(f.get_length()):
            self.show_item(str(i) + ". " + f.get_display(i))
        ans = self.get_string("Option: ")
        try:
            opt = int(ans)
            if opt >= i:
                # raise/show error/message about wrong option
                opt = -1
        except Exception, e:
            raise e
        f.set_value(f.get_value(opt))


# vim:tabstop=4:expandtab:smartindent
